package MPI;

public class Comm {
  public final static int NULL  = 0;
  public final static int SELF  = 1;
  public final static int WORLD = 2;

  public Comm() {}
  public Comm(int Type) { handle = GetComm(Type);}

  private Comm(long _handle) { handle = _handle;}  
  private native long GetComm(int Type);

  public native void Barrier();
  public native int Size();
  public native int Rank();

  private native void Send(Object buf, int offset, int baseSize, 
    int count, Datatype type, int dest, int tag);
  public void Send(Object buf, int offset, int count, 
    Datatype type, int dest, int tag)
  { Send(buf, offset, type.baseSize(), count, 
      type, dest, tag);}

  private native Status Recv(Object buf, int offset,
    int count, Datatype type, int source, int tag, Status stat);
  public Status Recv(Object buf, int offset, int count, 
    Datatype type, int source, int tag)
  { return Recv(buf, offset*type.baseSize(), 
      count, type, source, tag, new Status());}

  private native Status Sendrecv(
    Object sbuf, int soffset, int scount,
    Datatype stype, int dest, int stag,
    Object rbuf, int roffset, int rcount, 
    Datatype rtype, int source, int rtag, Status stat);
  public Status Sendrecv(
    Object sbuf, int soffset, int scount,
    Datatype stype, int dest, int stag,
    Object rbuf, int roffset, int rcount,
    Datatype rtype, int source, int rtag)
  { return Sendrecv(sbuf, soffset*stype.baseSize(), 
      scount, stype, dest, stag,
      rbuf, roffset*rtype.baseSize(), 
      rcount, rtype, source, rtag,
      new Status());}

/*
  public native void Bsend(Datatype buf, int dest, int tag);
  public native void Ssend(Datatype buf, int dest, int tag);
  public native void Rsend(Datatype buf, int dest, int tag);
  public native void Bcast(Datatype buf, int root);
  public native void Gather(Datatype sbuf, Datatype rbuf, int root);
  public native void Scatter(Datatype sbuf, Datatype rbuf, int root);
  public native void Allgather(Datatype sbuf, Datatype rbuf);
  public native void Alltoall(Datatype sbuf, Datatype rbuf);
  public native void Reduce(Datatype sbuf, Datatype rbuf, Op op, 
    int root);
*/
  protected long handle;
}

