package MPI;

public class MPI {

  static int MAX_PROCESSOR_NAME = 256;
  static public Comm COMM_WORLD;
  static public Op MAX, MIN, SUM, PROD, LAND, BAND,
    LOR, BOR, LXOR, BXOR, MINLOC, MAXLOC;
  static public Datatype BYTE, CHAR, SHORT, BOOLEAN, 
    INT, LONG, FLOAT, DOUBLE, PACKED, LB, UB;

  static private native void InitNative(String[] args);
  static public void Init(String[] args) {
    InitNative(args);
    MAX = new Op(Op.MAX);
    MIN = new Op(Op.MIN);
    SUM = new Op(Op.SUM);
    PROD = new Op(Op.PROD);
    LAND = new Op(Op.LAND);
    BAND = new Op(Op.BAND);
    LOR = new Op(Op.LOR);
    BOR = new Op(Op.BOR);
    LXOR = new Op(Op.LXOR);
    BXOR = new Op(Op.BXOR);
    MINLOC = new Op(Op.MINLOC);
    MAXLOC = new Op(Op.MAXLOC);
    BYTE = new Datatype(Datatype.BYTE);
    CHAR = new Datatype(Datatype.CHAR);
    SHORT = new Datatype(Datatype.SHORT);
    BOOLEAN = new Datatype(Datatype.BOOLEAN);
    INT = new Datatype(Datatype.INT);
    LONG = new Datatype(Datatype.LONG);
    FLOAT = new Datatype(Datatype.FLOAT);
    DOUBLE = new Datatype(Datatype.DOUBLE);
    PACKED = new Datatype(Datatype.PACKED);
    LB = new Datatype(Datatype.LB);
    UB = new Datatype(Datatype.UB);
    COMM_WORLD = new Comm(Comm.WORLD);
  }

  static public native void Finalize();

  static public native double Wtime();
  static public native double Wtick();

  static private native int Get_processor_name(byte[] buf);
  static public String Get_processor_name() {
    byte[] buf = new byte[MAX_PROCESSOR_NAME];
    return new String(buf, 0, 0, 
	  Get_processor_name(buf));
  }

  static public native void Buffer_attach(byte[] buf);
  static public native void Buffer_detach(byte[] buf);
   
  static {
    System.loadLibrary("MPI");
  }
}

