#include <mpi.h>
#include "MPI_MPI.h"
#include <stdlib.h>

#define REF(x) (*(void**)&(unhand(unhand(this)->x)->handle))

int len = 0;
char** sargs = 0;

void MPI_MPI_InitNative(struct HMPI_MPI *this, HArrayOfString *args) {
  int i;
  HString **data = unhand(args)->body;
  len = obj_length(args);
  sargs = (char**)calloc(len+1, sizeof(char*));
  for (i=0; i<len; i++)
    sargs[i] = allocCString(data[i]);
  sargs[len] = 0;
  MPI_Init(&len, &sargs);
}

void MPI_MPI_Finalize(struct HMPI_MPI *this) {
  int i;
  MPI_Finalize();
  for (i=0; i<len; i++) 
    free(sargs[i]);
  free(sargs);
}

long MPI_MPI_Get_processor_name(struct HMPI_MPI *this,
  HArrayOfByte *buf) {
  int len;
  MPI_Get_processor_name(unhand(buf)->body, &len);
  return len;
}

double MPI_MPI_Wtime(struct HMPI_MPI *this) {
  return MPI_Wtime();
}

double MPI_MPI_Wtick(struct HMPI_MPI *this) {
  return MPI_Wtick();
}

void MPI_MPI_Buffer_attach(struct HMPI_MPI *this,
  struct HArrayOfByte* buf) {
  MPI_Buffer_attach(unhand(buf)->body, obj_length(buf));
}

void MPI_MPI_Buffer_detach(struct HMPI_MPI *this,
  struct HArrayOfByte* buf) {
  int size;
  MPI_Buffer_detach(unhand(buf)->body, &size);
}

